<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 1.5.2: Character Counting</title>
<link href="sx4f.html" rev=precedes>
<link href="sx4h.html" rel=precedes>
<link href="sx4.html" rev=subdocument>
</head>
<body>
<H2>section 1.5.2: Character Counting</H2>

page 18
<p>Ignore the mention of efficiency with respect to 
<TT>nc = nc+1</TT> vs. <TT>++nc</TT>.
Once you've gotten used to <TT>++</TT> meaning ``increment by 1,''
you'll probably find yourself preferring <TT>++nc</TT>
simply because it is more concise,
and incrementing things by 1 is so common.
(Personally,
once I got used to it,
I found <TT>++</TT> more natural, too,
because after all,
expressions like <TT>nc = nc+1</TT>,
though they're common enough in programming,
are very unnatural from an algebraic perspective.)
</p><p>pages 18-19
</p><p>You may find it odd to have a loop with no body,
but such loops do crop up.
Just make sure that the explicit null statement
(or, if you prefer, empty <TT>{}</TT>)
marking the empty loop body is plainly visible.
</p><p>The whole first paragraph of page 19 counts as ``deep.''
A clean, well-designed loop will work properly for all of its 
``boundary conditions'':
zero trips through the loop,
one trip,
many trips,
maximum trips
(if there is any maximum,
and if so, also maximum minus one).
If a loop for some reason doesn't work at a particular boundary condition,
it's tempting to claim that that condition is rare or 
impossible and that the loop is therefore okay.
But if
the loop
can't handle
the boundary condition,
why can't it?
It's probably awkwardly constructed,
and straightening it out so
that it naturally handles all boundary conditions
will usually make it clearer and easier to understand
(and may also remove other lurking bugs).
</p><hr>
<p>
Read sequentially:
<a href="sx4f.html" rev=precedes>prev</a>
<a href="sx4h.html" rel=precedes>next</a>
<a href="sx4.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
